package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"reflect"
	"xorm.io/xorm"
)

type CentralKitchenForSchoolPackageOrd struct {
	Db         *xorm.Engine `json:"db"`
	OutTradeNo string       `json:"out_trade_no"`
}

func (centralKitchenForSchoolPackageOrdDb *CentralKitchenForSchoolPackageOrd) Set(outTradeNo string) { // set方法
	centralKitchenForSchoolPackageOrdDb.Db = Db
	centralKitchenForSchoolPackageOrdDb.OutTradeNo = outTradeNo
}

func (centralKitchenForSchoolPackageOrdDb *CentralKitchenForSchoolPackageOrd) GetCentralKitchenForSchoolPackageOrdById(id int) (m *model.CentralKitchenForSchoolPackageOrd, err error) {
	m = new(model.CentralKitchenForSchoolPackageOrd)
	has, err := centralKitchenForSchoolPackageOrdDb.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (centralKitchenForSchoolPackageOrdDb *CentralKitchenForSchoolPackageOrd) GetCentralKitchenForSchoolPackageOrd() (m *model.CentralKitchenForSchoolPackageOrd, err error) {
	m = new(model.CentralKitchenForSchoolPackageOrd)
	has, err := centralKitchenForSchoolPackageOrdDb.Db.Where("out_trade_no =?", centralKitchenForSchoolPackageOrdDb.OutTradeNo).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (centralKitchenForSchoolPackageOrdDb *CentralKitchenForSchoolPackageOrd) CentralKitchenForSchoolPackageOrdInsert(m *model.CentralKitchenForSchoolPackageOrd) (int, error) {
	_, err := centralKitchenForSchoolPackageOrdDb.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (centralKitchenForSchoolPackageOrdDb *CentralKitchenForSchoolPackageOrd) CentralKitchenForSchoolPackageOrdInsertBySession(session *xorm.Session, m *model.CentralKitchenForSchoolPackageOrd) (int, error) {
	_, err := session.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (centralKitchenForSchoolPackageOrdDb *CentralKitchenForSchoolPackageOrd) BatchAddCentralKitchenForSchoolPackageOrds(mm []*model.CentralKitchenForSchoolPackageOrd) (int64, error) {
	affected, err := centralKitchenForSchoolPackageOrdDb.Db.Insert(mm)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (centralKitchenForSchoolPackageOrdDb *CentralKitchenForSchoolPackageOrd) CentralKitchenForSchoolPackageOrdDeleteById(id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.CentralKitchenForSchoolPackageOrd{})
	} else {
		return Db.Where("id = ?", id).Delete(model.CentralKitchenForSchoolPackageOrd{})
	}
}

func (centralKitchenForSchoolPackageOrdDb *CentralKitchenForSchoolPackageOrd) CentralKitchenForSchoolPackageOrdDelete() (int64, error) {
	return Db.Where("out_trade_no = ?", centralKitchenForSchoolPackageOrdDb.OutTradeNo).Delete(model.CentralKitchenForSchoolPackageOrd{})
}

func (centralKitchenForSchoolPackageOrdDb *CentralKitchenForSchoolPackageOrd) CentralKitchenForSchoolPackageOrdUpdate(m *model.CentralKitchenForSchoolPackageOrd, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = centralKitchenForSchoolPackageOrdDb.Db.Where("out_trade_no=?", centralKitchenForSchoolPackageOrdDb.OutTradeNo).Cols(forceColums...).Update(m)
	} else {
		affected, err = centralKitchenForSchoolPackageOrdDb.Db.Where("out_trade_no=?", centralKitchenForSchoolPackageOrdDb.OutTradeNo).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

type CentralKitchenForSchoolPackageOrdWithUserIdentity struct {
	model.CentralKitchenForSchoolPackageOrd `xorm:"extends"`
	model.UserIdentity                      `xorm:"extends"`
	model.Enterprise                        `xorm:"extends"`
	model.User                              `xorm:"extends"`
	model.ClassWithUser                     `xorm:"extends"`
	model.Class                             `xorm:"extends"`
	model.Grade                             `xorm:"extends"`
}

func (CentralKitchenForSchoolPackageOrdWithUserIdentity) TableName() string {
	return "central_kitchen_for_school_package_ord"
}
